%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Moved_3D_Hole_Center_Node_Counter, Max_3D_Hole_Displacement] = Repair_RutFast_3D_Holes(Fastener_Index)

global ErrCode;

global DB_NODES;
global DB_MPC;

global AT_NODES;
global AT_MPC;

global DB_FASTENERS;

% Инициализация счетчиков
Moved_3D_Hole_Center_Node_Counter = 0;
Max_3D_Hole_Displacement = 0;

% Получение оси болта
[Axis_Point_1, Axis_Point_2, Axis_vector] = Get_Fastener_Axis(Fastener_Index); %#ok<ASGLU>

if (ErrCode < 0)
    return;
end

% Цикл по ярусам
for j=1:DB_FASTENERS{Fastener_Index}.N_layers

    % Если есть трехмерное отверстие
    if (strcmp(DB_FASTENERS{Fastener_Index}.Joint_topology{j}, 'rbe2_3d_hole') || strcmp(DB_FASTENERS{Fastener_Index}.Joint_topology{j}, 'bar_spider_3d_hole'))

        % Список узлов на стенке отверстия
        switch DB_FASTENERS{Fastener_Index}.Joint_topology{j}
            case 'rbe2_3d_hole'
                Node_list = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.Joint_mesh{j}.MPC_ID)}.dep_grid;
            case 'bar_spider_3d_hole'
                Node_list = DB_FASTENERS{Fastener_Index}.Joint_mesh{j}.Bar_Spider_Conn_Nodes_list;
        end

        % Получение параметров отверстия
        [Plate_Thickness, Hole_Diameter, Center_Point] = Get_3D_Hole_Parameters(Node_list, Axis_Point_1, Axis_Point_2); %#ok<ASGLU>

        % Проверка центрального узла MPC / bar-паука
        if (~Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Joint_nodes(j), Center_Point))

            % Вычисление перемещения
            Disp = norm(Center_Point - DB_NODES{AT_NODES(DB_FASTENERS{Fastener_Index}.Joint_nodes(j))}.Location);
            if (Disp > Max_3D_Hole_Displacement)
                Max_3D_Hole_Displacement = Disp;
            end

            % Перемещение узла в центр 3D отверстия
            Append_To_Output(PCL_Node_Move(DB_FASTENERS{Fastener_Index}.Joint_nodes(j), Center_Point));
            DB_Node_Move(DB_FASTENERS{Fastener_Index}.Joint_nodes(j), Center_Point);

            if (ErrCode < 0)
                return;
            end

            % Обновление счетчика
            Moved_3D_Hole_Center_Node_Counter = Moved_3D_Hole_Center_Node_Counter + 1;

        end

    end

end
